<?php

/**
 * @file
 * Waiting queue aggregate administration functionality.
 */

/**
 * Waiting queue aggregate administration form.
 */
function waiting_queue_aggregate_admin_form($form, $form_state) {

  $options = array();

  $cron_queues = module_invoke_all('cron_queue_info');
  drupal_alter('cron_queue_info', $cron_queues);
  foreach ($cron_queues as $queue_name => $subqueue_info) {
    if (isset($cron_queues[$queue_name]['worker callback'])) {
      $options[$queue_name]['queue'] = $queue_name;
      /** @var \DrupalQueueInterface $queue */
      $queue = DrupalQueue::get($queue_name);
      $options[$queue_name]['count'] = $queue->numberOfItems();
    }
  }

  // Check for modules implementing hook_queue_info().
  $queues = module_invoke_all('queue_info');
  drupal_alter('queue_info', $queues);
  foreach ($queues as $queue_name => $subqueue_info) {
    if (isset($cron_queues[$queue_name]['callback'])) {
      $options[$queue_name]['queue'] = $queue_name;
      /** @var \DrupalQueueInterface $queue */
      $queue = DrupalQueue::get($queue_name);
      $options[$queue_name]['count'] = $queue->numberOfItems();
    }
  }

  unset($options['waiting_queue_aggregate']);

  // Sort the selected options to the 'top'.
  $default_value = variable_get('waiting_queue_aggregate_enabled_queues', array());
  $sorted_options = array();

  foreach ($default_value as $value) {
    if (isset($options[$value])) {
      $sorted_options[$value] = $options[$value];
      unset($options[$value]);
    }
  }
  foreach ($options as $name => $value) {
    $sorted_options[$name] = $value;
  }

  $form['waiting_queue_aggregate_enabled_queues'] = array(
    '#type' => 'tableselect',
    '#header' => array(
      'queue' => t('Queue'),
      'count' => t('Number of items'),
    ),
    '#options' => $sorted_options,
    '#multiple' => TRUE,
    '#default_value' => drupal_map_assoc($default_value),
  );

  $form['array_filter'] = array(
    '#type' => 'value',
    '#value' => TRUE,
  );

  return system_settings_form($form);
}
